/* Process.c generated by valac 0.56.14, the Vala compiler
 * generated from Process.vala, do not modify */

/*
 * Copyright (c) 2011-2015 elementary LLC. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "power.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glibtop/proctime.h>
#include <glibtop.h>

enum  {
	POWER_SERVICES_PROCESS_MONITOR_PROCESS_0_PROPERTY,
	POWER_SERVICES_PROCESS_MONITOR_PROCESS_EXISTS_PROPERTY,
	POWER_SERVICES_PROCESS_MONITOR_PROCESS_PID_PROPERTY,
	POWER_SERVICES_PROCESS_MONITOR_PROCESS_PPID_PROPERTY,
	POWER_SERVICES_PROCESS_MONITOR_PROCESS_PGRP_PROPERTY,
	POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMM_PROPERTY,
	POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMMAND_PROPERTY,
	POWER_SERVICES_PROCESS_MONITOR_PROCESS_CPU_USAGE_PROPERTY,
	POWER_SERVICES_PROCESS_MONITOR_PROCESS_NUM_PROPERTIES
};
static GParamSpec* power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PowerServicesProcessMonitorProcessPrivate {
	gboolean _exists;
	gint _pid;
	gint _ppid;
	gint _pgrp;
	gchar* _comm;
	gchar* _command;
	gdouble _cpu_usage;
	guint64 cpu_last_used;
};

static gint PowerServicesProcessMonitorProcess_private_offset;
static gpointer power_services_process_monitor_process_parent_class = NULL;

static void power_services_process_monitor_process_set_pid (PowerServicesProcessMonitorProcess* self,
                                                     gint value);
static void power_services_process_monitor_process_set_cpu_usage (PowerServicesProcessMonitorProcess* self,
                                                           gdouble value);
static gboolean power_services_process_monitor_process_read_stat (PowerServicesProcessMonitorProcess* self,
                                                           guint64 cpu_total,
                                                           guint64 cpu_last_total);
static void power_services_process_monitor_process_set_exists (PowerServicesProcessMonitorProcess* self,
                                                        gboolean value);
static gboolean power_services_process_monitor_process_read_cmdline (PowerServicesProcessMonitorProcess* self);
static void power_services_process_monitor_process_set_comm (PowerServicesProcessMonitorProcess* self,
                                                      const gchar* value);
static void power_services_process_monitor_process_set_ppid (PowerServicesProcessMonitorProcess* self,
                                                      gint value);
static void power_services_process_monitor_process_set_pgrp (PowerServicesProcessMonitorProcess* self,
                                                      gint value);
static void power_services_process_monitor_process_set_command (PowerServicesProcessMonitorProcess* self,
                                                         const gchar* value);
static void power_services_process_monitor_process_finalize (GObject * obj);
static GType power_services_process_monitor_process_get_type_once (void);
static void _vala_power_services_process_monitor_process_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_power_services_process_monitor_process_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
power_services_process_monitor_process_get_instance_private (PowerServicesProcessMonitorProcess* self)
{
	return G_STRUCT_MEMBER_P (self, PowerServicesProcessMonitorProcess_private_offset);
}

/**
     * Construct a new process
     */
PowerServicesProcessMonitorProcess*
power_services_process_monitor_process_construct (GType object_type,
                                                  gint _pid)
{
	PowerServicesProcessMonitorProcess * self = NULL;
#line 63 "../src/Services/ProcessMonitor/Process.vala"
	self = (PowerServicesProcessMonitorProcess*) g_object_new (object_type, NULL);
#line 64 "../src/Services/ProcessMonitor/Process.vala"
	power_services_process_monitor_process_set_pid (self, _pid);
#line 66 "../src/Services/ProcessMonitor/Process.vala"
	power_services_process_monitor_process_set_cpu_usage (self, (gdouble) 0);
#line 68 "../src/Services/ProcessMonitor/Process.vala"
	power_services_process_monitor_process_set_exists (self, power_services_process_monitor_process_read_stat (self, (guint64) 0, (guint64) 1));
#line 69 "../src/Services/ProcessMonitor/Process.vala"
	power_services_process_monitor_process_read_cmdline (self);
#line 63 "../src/Services/ProcessMonitor/Process.vala"
	return self;
#line 130 "Process.c"
}

PowerServicesProcessMonitorProcess*
power_services_process_monitor_process_new (gint _pid)
{
#line 63 "../src/Services/ProcessMonitor/Process.vala"
	return power_services_process_monitor_process_construct (POWER_SERVICES_PROCESS_MONITOR_TYPE_PROCESS, _pid);
#line 138 "Process.c"
}

/**
     * Updates the process to get latest information
     *
     * Returns if the update was successful
     */
gboolean
power_services_process_monitor_process_update (PowerServicesProcessMonitorProcess* self,
                                               guint64 cpu_total,
                                               guint64 cpu_last_total)
{
	gboolean _tmp0_;
	gboolean result;
#line 77 "../src/Services/ProcessMonitor/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 78 "../src/Services/ProcessMonitor/Process.vala"
	power_services_process_monitor_process_set_exists (self, power_services_process_monitor_process_read_stat (self, cpu_total, cpu_last_total));
#line 80 "../src/Services/ProcessMonitor/Process.vala"
	_tmp0_ = self->priv->_exists;
#line 80 "../src/Services/ProcessMonitor/Process.vala"
	result = _tmp0_;
#line 80 "../src/Services/ProcessMonitor/Process.vala"
	return result;
#line 163 "Process.c"
}

/**
     * Reads the /proc/%pid%/stat file and updates the process with the information therein.
     */
static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1491 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1492 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1492 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1492 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1493 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		start = string_length + start;
#line 193 "Process.c"
	}
#line 1496 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		end = string_length + end;
#line 199 "Process.c"
	}
#line 1499 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 205 "Process.c"
	} else {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 209 "Process.c"
	}
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1500 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 217 "Process.c"
	} else {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 221 "Process.c"
	}
#line 1500 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1502 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1502 "glib-2.0.vapi"
	result = _tmp4_;
#line 1502 "glib-2.0.vapi"
	return result;
#line 233 "Process.c"
}

static gboolean
power_services_process_monitor_process_read_stat (PowerServicesProcessMonitorProcess* self,
                                                  guint64 cpu_total,
                                                  guint64 cpu_last_total)
{
	GFile* stat_file = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 86 "../src/Services/ProcessMonitor/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "../src/Services/ProcessMonitor/Process.vala"
	_tmp0_ = self->priv->_pid;
#line 88 "../src/Services/ProcessMonitor/Process.vala"
	_tmp1_ = g_strdup_printf ("/proc/%d/stat", _tmp0_);
#line 88 "../src/Services/ProcessMonitor/Process.vala"
	_tmp2_ = _tmp1_;
#line 88 "../src/Services/ProcessMonitor/Process.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 88 "../src/Services/ProcessMonitor/Process.vala"
	_tmp4_ = _tmp3_;
#line 88 "../src/Services/ProcessMonitor/Process.vala"
	_g_free0 (_tmp2_);
#line 88 "../src/Services/ProcessMonitor/Process.vala"
	stat_file = _tmp4_;
#line 91 "../src/Services/ProcessMonitor/Process.vala"
	_tmp5_ = stat_file;
#line 91 "../src/Services/ProcessMonitor/Process.vala"
	if (!g_file_query_exists (_tmp5_, NULL)) {
#line 92 "../src/Services/ProcessMonitor/Process.vala"
		result = FALSE;
#line 92 "../src/Services/ProcessMonitor/Process.vala"
		_g_object_unref0 (stat_file);
#line 92 "../src/Services/ProcessMonitor/Process.vala"
		return result;
#line 276 "Process.c"
	}
	{
		GFileInputStream* _tmp6_ = NULL;
		GFile* _tmp7_;
		GFileInputStream* _tmp8_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp9_;
		gchar* stat_contents = NULL;
		GDataInputStream* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar** stat = NULL;
		const gchar* _tmp17_;
		gchar** _tmp18_;
		gchar** _tmp19_;
		gint stat_length1;
		gint _stat_size_;
		gchar** _tmp20_;
		gint _tmp20__length1;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar** _tmp24_;
		gint _tmp24__length1;
		const gchar* _tmp25_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		const gchar* _tmp27_;
		glibtop_proc_time proc_time = {0};
		gint _tmp28_;
		glibtop_proc_time _tmp29_ = {0};
		glibtop_proc_time _tmp30_;
		glibtop_proc_time _tmp31_;
#line 97 "../src/Services/ProcessMonitor/Process.vala"
		_tmp7_ = stat_file;
#line 97 "../src/Services/ProcessMonitor/Process.vala"
		_tmp8_ = g_file_read (_tmp7_, NULL, &_inner_error0_);
#line 97 "../src/Services/ProcessMonitor/Process.vala"
		_tmp6_ = _tmp8_;
#line 97 "../src/Services/ProcessMonitor/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "Process.c"
			goto __catch0_g_error;
		}
#line 97 "../src/Services/ProcessMonitor/Process.vala"
		_tmp9_ = g_data_input_stream_new ((GInputStream*) _tmp6_);
#line 97 "../src/Services/ProcessMonitor/Process.vala"
		dis = _tmp9_;
#line 98 "../src/Services/ProcessMonitor/Process.vala"
		_tmp10_ = dis;
#line 98 "../src/Services/ProcessMonitor/Process.vala"
		_tmp11_ = g_data_input_stream_read_line (_tmp10_, NULL, NULL, &_inner_error0_);
#line 98 "../src/Services/ProcessMonitor/Process.vala"
		stat_contents = _tmp11_;
#line 98 "../src/Services/ProcessMonitor/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/Services/ProcessMonitor/Process.vala"
			_g_object_unref0 (dis);
#line 98 "../src/Services/ProcessMonitor/Process.vala"
			_g_object_unref0 (_tmp6_);
#line 337 "Process.c"
			goto __catch0_g_error;
		}
#line 100 "../src/Services/ProcessMonitor/Process.vala"
		_tmp12_ = stat_contents;
#line 100 "../src/Services/ProcessMonitor/Process.vala"
		if (_tmp12_ == NULL) {
#line 344 "Process.c"
			FILE* _tmp13_;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 101 "../src/Services/ProcessMonitor/Process.vala"
			_tmp13_ = stderr;
#line 101 "../src/Services/ProcessMonitor/Process.vala"
			_tmp14_ = stat_file;
#line 101 "../src/Services/ProcessMonitor/Process.vala"
			_tmp15_ = g_file_get_path (_tmp14_);
#line 101 "../src/Services/ProcessMonitor/Process.vala"
			_tmp16_ = _tmp15_;
#line 101 "../src/Services/ProcessMonitor/Process.vala"
			fprintf (_tmp13_, "Error reading stat file '%s': couldn't read_line ()\n", _tmp16_);
#line 101 "../src/Services/ProcessMonitor/Process.vala"
			_g_free0 (_tmp16_);
#line 103 "../src/Services/ProcessMonitor/Process.vala"
			result = FALSE;
#line 103 "../src/Services/ProcessMonitor/Process.vala"
			_g_free0 (stat_contents);
#line 103 "../src/Services/ProcessMonitor/Process.vala"
			_g_object_unref0 (dis);
#line 103 "../src/Services/ProcessMonitor/Process.vala"
			_g_object_unref0 (_tmp6_);
#line 103 "../src/Services/ProcessMonitor/Process.vala"
			_g_object_unref0 (stat_file);
#line 103 "../src/Services/ProcessMonitor/Process.vala"
			return result;
#line 373 "Process.c"
		}
#line 107 "../src/Services/ProcessMonitor/Process.vala"
		_tmp17_ = stat_contents;
#line 107 "../src/Services/ProcessMonitor/Process.vala"
		_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, " ", 0);
#line 107 "../src/Services/ProcessMonitor/Process.vala"
		stat = _tmp19_;
#line 107 "../src/Services/ProcessMonitor/Process.vala"
		stat_length1 = _vala_array_length (_tmp18_);
#line 107 "../src/Services/ProcessMonitor/Process.vala"
		_stat_size_ = stat_length1;
#line 109 "../src/Services/ProcessMonitor/Process.vala"
		_tmp20_ = stat;
#line 109 "../src/Services/ProcessMonitor/Process.vala"
		_tmp20__length1 = stat_length1;
#line 109 "../src/Services/ProcessMonitor/Process.vala"
		_tmp21_ = _tmp20_[1];
#line 109 "../src/Services/ProcessMonitor/Process.vala"
		_tmp22_ = string_slice (_tmp21_, (glong) 1, (glong) -1);
#line 109 "../src/Services/ProcessMonitor/Process.vala"
		_tmp23_ = _tmp22_;
#line 109 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_comm (self, _tmp23_);
#line 109 "../src/Services/ProcessMonitor/Process.vala"
		_g_free0 (_tmp23_);
#line 111 "../src/Services/ProcessMonitor/Process.vala"
		_tmp24_ = stat;
#line 111 "../src/Services/ProcessMonitor/Process.vala"
		_tmp24__length1 = stat_length1;
#line 111 "../src/Services/ProcessMonitor/Process.vala"
		_tmp25_ = _tmp24_[3];
#line 111 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_ppid (self, atoi (_tmp25_));
#line 112 "../src/Services/ProcessMonitor/Process.vala"
		_tmp26_ = stat;
#line 112 "../src/Services/ProcessMonitor/Process.vala"
		_tmp26__length1 = stat_length1;
#line 112 "../src/Services/ProcessMonitor/Process.vala"
		_tmp27_ = _tmp26_[4];
#line 112 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_pgrp (self, atoi (_tmp27_));
#line 115 "../src/Services/ProcessMonitor/Process.vala"
		_tmp28_ = self->priv->_pid;
#line 115 "../src/Services/ProcessMonitor/Process.vala"
		glibtop_get_proc_time (&_tmp29_, _tmp28_);
#line 115 "../src/Services/ProcessMonitor/Process.vala"
		proc_time = _tmp29_;
#line 116 "../src/Services/ProcessMonitor/Process.vala"
		_tmp30_ = proc_time;
#line 116 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_cpu_usage (self, ((gdouble) (_tmp30_.rtime - self->priv->cpu_last_used)) / (cpu_total - cpu_last_total));
#line 117 "../src/Services/ProcessMonitor/Process.vala"
		_tmp31_ = proc_time;
#line 117 "../src/Services/ProcessMonitor/Process.vala"
		self->priv->cpu_last_used = _tmp31_.rtime;
#line 95 "../src/Services/ProcessMonitor/Process.vala"
		stat = (_vala_array_free (stat, stat_length1, (GDestroyNotify) g_free), NULL);
#line 95 "../src/Services/ProcessMonitor/Process.vala"
		_g_free0 (stat_contents);
#line 95 "../src/Services/ProcessMonitor/Process.vala"
		_g_object_unref0 (dis);
#line 95 "../src/Services/ProcessMonitor/Process.vala"
		_g_object_unref0 (_tmp6_);
#line 437 "Process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp32_;
		GFile* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		GError* _tmp36_;
		const gchar* _tmp37_;
#line 95 "../src/Services/ProcessMonitor/Process.vala"
		e = _inner_error0_;
#line 95 "../src/Services/ProcessMonitor/Process.vala"
		_inner_error0_ = NULL;
#line 119 "../src/Services/ProcessMonitor/Process.vala"
		_tmp32_ = stderr;
#line 119 "../src/Services/ProcessMonitor/Process.vala"
		_tmp33_ = stat_file;
#line 119 "../src/Services/ProcessMonitor/Process.vala"
		_tmp34_ = g_file_get_path (_tmp33_);
#line 119 "../src/Services/ProcessMonitor/Process.vala"
		_tmp35_ = _tmp34_;
#line 119 "../src/Services/ProcessMonitor/Process.vala"
		_tmp36_ = e;
#line 119 "../src/Services/ProcessMonitor/Process.vala"
		_tmp37_ = _tmp36_->message;
#line 119 "../src/Services/ProcessMonitor/Process.vala"
		fprintf (_tmp32_, "Error reading stat file '%s': %s\n", _tmp35_, _tmp37_);
#line 119 "../src/Services/ProcessMonitor/Process.vala"
		_g_free0 (_tmp35_);
#line 121 "../src/Services/ProcessMonitor/Process.vala"
		result = FALSE;
#line 121 "../src/Services/ProcessMonitor/Process.vala"
		_g_error_free0 (e);
#line 121 "../src/Services/ProcessMonitor/Process.vala"
		_g_object_unref0 (stat_file);
#line 121 "../src/Services/ProcessMonitor/Process.vala"
		return result;
#line 477 "Process.c"
	}
	__finally0:
#line 95 "../src/Services/ProcessMonitor/Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 482 "Process.c"
		gboolean _tmp38_ = FALSE;
#line 95 "../src/Services/ProcessMonitor/Process.vala"
		_g_object_unref0 (stat_file);
#line 95 "../src/Services/ProcessMonitor/Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 95 "../src/Services/ProcessMonitor/Process.vala"
		g_clear_error (&_inner_error0_);
#line 95 "../src/Services/ProcessMonitor/Process.vala"
		return _tmp38_;
#line 492 "Process.c"
	}
#line 124 "../src/Services/ProcessMonitor/Process.vala"
	result = TRUE;
#line 124 "../src/Services/ProcessMonitor/Process.vala"
	_g_object_unref0 (stat_file);
#line 124 "../src/Services/ProcessMonitor/Process.vala"
	return result;
#line 500 "Process.c"
}

/**
     * Reads the /proc/%pid%/cmdline file and updates from the information contained therein.
     */
static gboolean
power_services_process_monitor_process_read_cmdline (PowerServicesProcessMonitorProcess* self)
{
	GFile* cmdline_file = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 130 "../src/Services/ProcessMonitor/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 132 "../src/Services/ProcessMonitor/Process.vala"
	_tmp0_ = self->priv->_pid;
#line 132 "../src/Services/ProcessMonitor/Process.vala"
	_tmp1_ = g_strdup_printf ("/proc/%d/cmdline", _tmp0_);
#line 132 "../src/Services/ProcessMonitor/Process.vala"
	_tmp2_ = _tmp1_;
#line 132 "../src/Services/ProcessMonitor/Process.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 132 "../src/Services/ProcessMonitor/Process.vala"
	_tmp4_ = _tmp3_;
#line 132 "../src/Services/ProcessMonitor/Process.vala"
	_g_free0 (_tmp2_);
#line 132 "../src/Services/ProcessMonitor/Process.vala"
	cmdline_file = _tmp4_;
#line 135 "../src/Services/ProcessMonitor/Process.vala"
	_tmp5_ = cmdline_file;
#line 135 "../src/Services/ProcessMonitor/Process.vala"
	if (!g_file_query_exists (_tmp5_, NULL)) {
#line 538 "Process.c"
		FILE* _tmp6_;
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 136 "../src/Services/ProcessMonitor/Process.vala"
		_tmp6_ = stderr;
#line 136 "../src/Services/ProcessMonitor/Process.vala"
		_tmp7_ = cmdline_file;
#line 136 "../src/Services/ProcessMonitor/Process.vala"
		_tmp8_ = g_file_get_path (_tmp7_);
#line 136 "../src/Services/ProcessMonitor/Process.vala"
		_tmp9_ = _tmp8_;
#line 136 "../src/Services/ProcessMonitor/Process.vala"
		fprintf (_tmp6_, "File '%s' doesn't exist.\n", _tmp9_);
#line 136 "../src/Services/ProcessMonitor/Process.vala"
		_g_free0 (_tmp9_);
#line 138 "../src/Services/ProcessMonitor/Process.vala"
		result = FALSE;
#line 138 "../src/Services/ProcessMonitor/Process.vala"
		_g_object_unref0 (cmdline_file);
#line 138 "../src/Services/ProcessMonitor/Process.vala"
		return result;
#line 561 "Process.c"
	}
	{
		GFileInputStream* _tmp10_ = NULL;
		GFile* _tmp11_;
		GFileInputStream* _tmp12_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp13_;
		guint8* cmdline_contents_array = NULL;
		guint8* _tmp14_;
		gint cmdline_contents_array_length1;
		gint _cmdline_contents_array_size_;
		gssize size = 0L;
		GDataInputStream* _tmp15_;
		guint8* _tmp16_;
		gint _tmp16__length1;
		guint8* _tmp25_;
		gint _tmp25__length1;
		gchar* cmdline_contents = NULL;
		guint8* _tmp26_;
		gint _tmp26__length1;
		gchar* _tmp27_;
		const gchar* _tmp28_;
#line 143 "../src/Services/ProcessMonitor/Process.vala"
		_tmp11_ = cmdline_file;
#line 143 "../src/Services/ProcessMonitor/Process.vala"
		_tmp12_ = g_file_read (_tmp11_, NULL, &_inner_error0_);
#line 143 "../src/Services/ProcessMonitor/Process.vala"
		_tmp10_ = _tmp12_;
#line 143 "../src/Services/ProcessMonitor/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 592 "Process.c"
			goto __catch0_g_error;
		}
#line 143 "../src/Services/ProcessMonitor/Process.vala"
		_tmp13_ = g_data_input_stream_new ((GInputStream*) _tmp10_);
#line 143 "../src/Services/ProcessMonitor/Process.vala"
		dis = _tmp13_;
#line 144 "../src/Services/ProcessMonitor/Process.vala"
		_tmp14_ = g_new0 (guint8, 4097);
#line 144 "../src/Services/ProcessMonitor/Process.vala"
		cmdline_contents_array = _tmp14_;
#line 144 "../src/Services/ProcessMonitor/Process.vala"
		cmdline_contents_array_length1 = 4097;
#line 144 "../src/Services/ProcessMonitor/Process.vala"
		_cmdline_contents_array_size_ = cmdline_contents_array_length1;
#line 145 "../src/Services/ProcessMonitor/Process.vala"
		_tmp15_ = dis;
#line 145 "../src/Services/ProcessMonitor/Process.vala"
		_tmp16_ = cmdline_contents_array;
#line 145 "../src/Services/ProcessMonitor/Process.vala"
		_tmp16__length1 = cmdline_contents_array_length1;
#line 145 "../src/Services/ProcessMonitor/Process.vala"
		size = g_input_stream_read ((GInputStream*) _tmp15_, _tmp16_, (gsize) _tmp16__length1, NULL, &_inner_error0_);
#line 145 "../src/Services/ProcessMonitor/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "../src/Services/ProcessMonitor/Process.vala"
			cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
#line 145 "../src/Services/ProcessMonitor/Process.vala"
			_g_object_unref0 (dis);
#line 145 "../src/Services/ProcessMonitor/Process.vala"
			_g_object_unref0 (_tmp10_);
#line 623 "Process.c"
			goto __catch0_g_error;
		}
#line 147 "../src/Services/ProcessMonitor/Process.vala"
		if (size <= ((gssize) 0)) {
#line 149 "../src/Services/ProcessMonitor/Process.vala"
			result = TRUE;
#line 149 "../src/Services/ProcessMonitor/Process.vala"
			cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
#line 149 "../src/Services/ProcessMonitor/Process.vala"
			_g_object_unref0 (dis);
#line 149 "../src/Services/ProcessMonitor/Process.vala"
			_g_object_unref0 (_tmp10_);
#line 149 "../src/Services/ProcessMonitor/Process.vala"
			_g_object_unref0 (cmdline_file);
#line 149 "../src/Services/ProcessMonitor/Process.vala"
			return result;
#line 640 "Process.c"
		}
		{
			gint pos = 0;
#line 156 "../src/Services/ProcessMonitor/Process.vala"
			pos = 0;
#line 646 "Process.c"
			{
				gboolean _tmp17_ = FALSE;
#line 156 "../src/Services/ProcessMonitor/Process.vala"
				_tmp17_ = TRUE;
#line 156 "../src/Services/ProcessMonitor/Process.vala"
				while (TRUE) {
#line 653 "Process.c"
					gboolean _tmp19_ = FALSE;
					guint8* _tmp20_;
					gint _tmp20__length1;
					guint8 _tmp21_;
#line 156 "../src/Services/ProcessMonitor/Process.vala"
					if (!_tmp17_) {
#line 660 "Process.c"
						gint _tmp18_;
#line 156 "../src/Services/ProcessMonitor/Process.vala"
						_tmp18_ = pos;
#line 156 "../src/Services/ProcessMonitor/Process.vala"
						pos = _tmp18_ + 1;
#line 666 "Process.c"
					}
#line 156 "../src/Services/ProcessMonitor/Process.vala"
					_tmp17_ = FALSE;
#line 156 "../src/Services/ProcessMonitor/Process.vala"
					if (!(((gssize) pos) < size)) {
#line 156 "../src/Services/ProcessMonitor/Process.vala"
						break;
#line 674 "Process.c"
					}
#line 157 "../src/Services/ProcessMonitor/Process.vala"
					_tmp20_ = cmdline_contents_array;
#line 157 "../src/Services/ProcessMonitor/Process.vala"
					_tmp20__length1 = cmdline_contents_array_length1;
#line 157 "../src/Services/ProcessMonitor/Process.vala"
					_tmp21_ = _tmp20_[pos];
#line 157 "../src/Services/ProcessMonitor/Process.vala"
					if (_tmp21_ == ((guint8) '\0')) {
#line 157 "../src/Services/ProcessMonitor/Process.vala"
						_tmp19_ = TRUE;
#line 686 "Process.c"
					} else {
						guint8* _tmp22_;
						gint _tmp22__length1;
						guint8 _tmp23_;
#line 157 "../src/Services/ProcessMonitor/Process.vala"
						_tmp22_ = cmdline_contents_array;
#line 157 "../src/Services/ProcessMonitor/Process.vala"
						_tmp22__length1 = cmdline_contents_array_length1;
#line 157 "../src/Services/ProcessMonitor/Process.vala"
						_tmp23_ = _tmp22_[pos];
#line 157 "../src/Services/ProcessMonitor/Process.vala"
						_tmp19_ = _tmp23_ == ((guint8) '\n');
#line 699 "Process.c"
					}
#line 157 "../src/Services/ProcessMonitor/Process.vala"
					if (_tmp19_) {
#line 703 "Process.c"
						guint8* _tmp24_;
						gint _tmp24__length1;
#line 158 "../src/Services/ProcessMonitor/Process.vala"
						_tmp24_ = cmdline_contents_array;
#line 158 "../src/Services/ProcessMonitor/Process.vala"
						_tmp24__length1 = cmdline_contents_array_length1;
#line 158 "../src/Services/ProcessMonitor/Process.vala"
						_tmp24_[pos] = (guint8) ' ';
#line 712 "Process.c"
					}
				}
			}
		}
#line 162 "../src/Services/ProcessMonitor/Process.vala"
		_tmp25_ = cmdline_contents_array;
#line 162 "../src/Services/ProcessMonitor/Process.vala"
		_tmp25__length1 = cmdline_contents_array_length1;
#line 162 "../src/Services/ProcessMonitor/Process.vala"
		_tmp25_[size] = (guint8) '\0';
#line 163 "../src/Services/ProcessMonitor/Process.vala"
		_tmp26_ = cmdline_contents_array;
#line 163 "../src/Services/ProcessMonitor/Process.vala"
		_tmp26__length1 = cmdline_contents_array_length1;
#line 163 "../src/Services/ProcessMonitor/Process.vala"
		_tmp27_ = g_strdup ((const gchar*) _tmp26_);
#line 163 "../src/Services/ProcessMonitor/Process.vala"
		cmdline_contents = _tmp27_;
#line 166 "../src/Services/ProcessMonitor/Process.vala"
		_tmp28_ = cmdline_contents;
#line 166 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_command (self, _tmp28_);
#line 141 "../src/Services/ProcessMonitor/Process.vala"
		_g_free0 (cmdline_contents);
#line 141 "../src/Services/ProcessMonitor/Process.vala"
		cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
#line 141 "../src/Services/ProcessMonitor/Process.vala"
		_g_object_unref0 (dis);
#line 141 "../src/Services/ProcessMonitor/Process.vala"
		_g_object_unref0 (_tmp10_);
#line 743 "Process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp29_;
		GFile* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		GError* _tmp33_;
		const gchar* _tmp34_;
#line 141 "../src/Services/ProcessMonitor/Process.vala"
		e = _inner_error0_;
#line 141 "../src/Services/ProcessMonitor/Process.vala"
		_inner_error0_ = NULL;
#line 169 "../src/Services/ProcessMonitor/Process.vala"
		_tmp29_ = stderr;
#line 169 "../src/Services/ProcessMonitor/Process.vala"
		_tmp30_ = cmdline_file;
#line 169 "../src/Services/ProcessMonitor/Process.vala"
		_tmp31_ = g_file_get_path (_tmp30_);
#line 169 "../src/Services/ProcessMonitor/Process.vala"
		_tmp32_ = _tmp31_;
#line 169 "../src/Services/ProcessMonitor/Process.vala"
		_tmp33_ = e;
#line 169 "../src/Services/ProcessMonitor/Process.vala"
		_tmp34_ = _tmp33_->message;
#line 169 "../src/Services/ProcessMonitor/Process.vala"
		fprintf (_tmp29_, "Error reading cmdline file '%s': %s\n", _tmp32_, _tmp34_);
#line 169 "../src/Services/ProcessMonitor/Process.vala"
		_g_free0 (_tmp32_);
#line 171 "../src/Services/ProcessMonitor/Process.vala"
		result = FALSE;
#line 171 "../src/Services/ProcessMonitor/Process.vala"
		_g_error_free0 (e);
#line 171 "../src/Services/ProcessMonitor/Process.vala"
		_g_object_unref0 (cmdline_file);
#line 171 "../src/Services/ProcessMonitor/Process.vala"
		return result;
#line 783 "Process.c"
	}
	__finally0:
#line 141 "../src/Services/ProcessMonitor/Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 788 "Process.c"
		gboolean _tmp35_ = FALSE;
#line 141 "../src/Services/ProcessMonitor/Process.vala"
		_g_object_unref0 (cmdline_file);
#line 141 "../src/Services/ProcessMonitor/Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 141 "../src/Services/ProcessMonitor/Process.vala"
		g_clear_error (&_inner_error0_);
#line 141 "../src/Services/ProcessMonitor/Process.vala"
		return _tmp35_;
#line 798 "Process.c"
	}
#line 174 "../src/Services/ProcessMonitor/Process.vala"
	result = TRUE;
#line 174 "../src/Services/ProcessMonitor/Process.vala"
	_g_object_unref0 (cmdline_file);
#line 174 "../src/Services/ProcessMonitor/Process.vala"
	return result;
#line 806 "Process.c"
}

gboolean
power_services_process_monitor_process_get_exists (PowerServicesProcessMonitorProcess* self)
{
	gboolean result;
#line 24 "../src/Services/ProcessMonitor/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24 "../src/Services/ProcessMonitor/Process.vala"
	result = self->priv->_exists;
#line 24 "../src/Services/ProcessMonitor/Process.vala"
	return result;
#line 819 "Process.c"
}

static void
power_services_process_monitor_process_set_exists (PowerServicesProcessMonitorProcess* self,
                                                   gboolean value)
{
	gboolean old_value;
#line 24 "../src/Services/ProcessMonitor/Process.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Services/ProcessMonitor/Process.vala"
	old_value = power_services_process_monitor_process_get_exists (self);
#line 24 "../src/Services/ProcessMonitor/Process.vala"
	if (old_value != value) {
#line 24 "../src/Services/ProcessMonitor/Process.vala"
		self->priv->_exists = value;
#line 24 "../src/Services/ProcessMonitor/Process.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_EXISTS_PROPERTY]);
#line 837 "Process.c"
	}
}

gint
power_services_process_monitor_process_get_pid (PowerServicesProcessMonitorProcess* self)
{
	gint result;
#line 29 "../src/Services/ProcessMonitor/Process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 29 "../src/Services/ProcessMonitor/Process.vala"
	result = self->priv->_pid;
#line 29 "../src/Services/ProcessMonitor/Process.vala"
	return result;
#line 851 "Process.c"
}

static void
power_services_process_monitor_process_set_pid (PowerServicesProcessMonitorProcess* self,
                                                gint value)
{
	gint old_value;
#line 29 "../src/Services/ProcessMonitor/Process.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/ProcessMonitor/Process.vala"
	old_value = power_services_process_monitor_process_get_pid (self);
#line 29 "../src/Services/ProcessMonitor/Process.vala"
	if (old_value != value) {
#line 29 "../src/Services/ProcessMonitor/Process.vala"
		self->priv->_pid = value;
#line 29 "../src/Services/ProcessMonitor/Process.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_PID_PROPERTY]);
#line 869 "Process.c"
	}
}

gint
power_services_process_monitor_process_get_ppid (PowerServicesProcessMonitorProcess* self)
{
	gint result;
#line 34 "../src/Services/ProcessMonitor/Process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "../src/Services/ProcessMonitor/Process.vala"
	result = self->priv->_ppid;
#line 34 "../src/Services/ProcessMonitor/Process.vala"
	return result;
#line 883 "Process.c"
}

static void
power_services_process_monitor_process_set_ppid (PowerServicesProcessMonitorProcess* self,
                                                 gint value)
{
	gint old_value;
#line 34 "../src/Services/ProcessMonitor/Process.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Services/ProcessMonitor/Process.vala"
	old_value = power_services_process_monitor_process_get_ppid (self);
#line 34 "../src/Services/ProcessMonitor/Process.vala"
	if (old_value != value) {
#line 34 "../src/Services/ProcessMonitor/Process.vala"
		self->priv->_ppid = value;
#line 34 "../src/Services/ProcessMonitor/Process.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_PPID_PROPERTY]);
#line 901 "Process.c"
	}
}

gint
power_services_process_monitor_process_get_pgrp (PowerServicesProcessMonitorProcess* self)
{
	gint result;
#line 39 "../src/Services/ProcessMonitor/Process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../src/Services/ProcessMonitor/Process.vala"
	result = self->priv->_pgrp;
#line 39 "../src/Services/ProcessMonitor/Process.vala"
	return result;
#line 915 "Process.c"
}

static void
power_services_process_monitor_process_set_pgrp (PowerServicesProcessMonitorProcess* self,
                                                 gint value)
{
	gint old_value;
#line 39 "../src/Services/ProcessMonitor/Process.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Services/ProcessMonitor/Process.vala"
	old_value = power_services_process_monitor_process_get_pgrp (self);
#line 39 "../src/Services/ProcessMonitor/Process.vala"
	if (old_value != value) {
#line 39 "../src/Services/ProcessMonitor/Process.vala"
		self->priv->_pgrp = value;
#line 39 "../src/Services/ProcessMonitor/Process.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_PGRP_PROPERTY]);
#line 933 "Process.c"
	}
}

const gchar*
power_services_process_monitor_process_get_comm (PowerServicesProcessMonitorProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "../src/Services/ProcessMonitor/Process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/Services/ProcessMonitor/Process.vala"
	_tmp0_ = self->priv->_comm;
#line 44 "../src/Services/ProcessMonitor/Process.vala"
	result = _tmp0_;
#line 44 "../src/Services/ProcessMonitor/Process.vala"
	return result;
#line 950 "Process.c"
}

static void
power_services_process_monitor_process_set_comm (PowerServicesProcessMonitorProcess* self,
                                                 const gchar* value)
{
	gchar* old_value;
#line 44 "../src/Services/ProcessMonitor/Process.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/Services/ProcessMonitor/Process.vala"
	old_value = power_services_process_monitor_process_get_comm (self);
#line 44 "../src/Services/ProcessMonitor/Process.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 964 "Process.c"
		gchar* _tmp0_;
#line 44 "../src/Services/ProcessMonitor/Process.vala"
		_tmp0_ = g_strdup (value);
#line 44 "../src/Services/ProcessMonitor/Process.vala"
		_g_free0 (self->priv->_comm);
#line 44 "../src/Services/ProcessMonitor/Process.vala"
		self->priv->_comm = _tmp0_;
#line 44 "../src/Services/ProcessMonitor/Process.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMM_PROPERTY]);
#line 974 "Process.c"
	}
}

const gchar*
power_services_process_monitor_process_get_command (PowerServicesProcessMonitorProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/Services/ProcessMonitor/Process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/Services/ProcessMonitor/Process.vala"
	_tmp0_ = self->priv->_command;
#line 49 "../src/Services/ProcessMonitor/Process.vala"
	result = _tmp0_;
#line 49 "../src/Services/ProcessMonitor/Process.vala"
	return result;
#line 991 "Process.c"
}

static void
power_services_process_monitor_process_set_command (PowerServicesProcessMonitorProcess* self,
                                                    const gchar* value)
{
	gchar* old_value;
#line 49 "../src/Services/ProcessMonitor/Process.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Services/ProcessMonitor/Process.vala"
	old_value = power_services_process_monitor_process_get_command (self);
#line 49 "../src/Services/ProcessMonitor/Process.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1005 "Process.c"
		gchar* _tmp0_;
#line 49 "../src/Services/ProcessMonitor/Process.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../src/Services/ProcessMonitor/Process.vala"
		_g_free0 (self->priv->_command);
#line 49 "../src/Services/ProcessMonitor/Process.vala"
		self->priv->_command = _tmp0_;
#line 49 "../src/Services/ProcessMonitor/Process.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMMAND_PROPERTY]);
#line 1015 "Process.c"
	}
}

gdouble
power_services_process_monitor_process_get_cpu_usage (PowerServicesProcessMonitorProcess* self)
{
	gdouble result;
#line 56 "../src/Services/ProcessMonitor/Process.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 56 "../src/Services/ProcessMonitor/Process.vala"
	result = self->priv->_cpu_usage;
#line 56 "../src/Services/ProcessMonitor/Process.vala"
	return result;
#line 1029 "Process.c"
}

static void
power_services_process_monitor_process_set_cpu_usage (PowerServicesProcessMonitorProcess* self,
                                                      gdouble value)
{
	gdouble old_value;
#line 56 "../src/Services/ProcessMonitor/Process.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Services/ProcessMonitor/Process.vala"
	old_value = power_services_process_monitor_process_get_cpu_usage (self);
#line 56 "../src/Services/ProcessMonitor/Process.vala"
	if (old_value != value) {
#line 56 "../src/Services/ProcessMonitor/Process.vala"
		self->priv->_cpu_usage = value;
#line 56 "../src/Services/ProcessMonitor/Process.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_CPU_USAGE_PROPERTY]);
#line 1047 "Process.c"
	}
}

static void
power_services_process_monitor_process_class_init (PowerServicesProcessMonitorProcessClass * klass,
                                                   gpointer klass_data)
{
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	power_services_process_monitor_process_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	g_type_class_adjust_private_offset (klass, &PowerServicesProcessMonitorProcess_private_offset);
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_power_services_process_monitor_process_get_property;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_power_services_process_monitor_process_set_property;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	G_OBJECT_CLASS (klass)->finalize = power_services_process_monitor_process_finalize;
#line 1065 "Process.c"
	/**
	     * Whether or not the PID leads to something
	     */
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_PROCESS_MONITOR_PROCESS_EXISTS_PROPERTY, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_EXISTS_PROPERTY] = g_param_spec_boolean ("exists", "exists", "exists", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1071 "Process.c"
	/**
	     * Process ID
	     */
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_PROCESS_MONITOR_PROCESS_PID_PROPERTY, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_PID_PROPERTY] = g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1077 "Process.c"
	/**
	     * Parent Process ID
	     */
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_PROCESS_MONITOR_PROCESS_PPID_PROPERTY, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_PPID_PROPERTY] = g_param_spec_int ("ppid", "ppid", "ppid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1083 "Process.c"
	/**
	     * Process Group ID; 0 if a kernal process/thread
	     */
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_PROCESS_MONITOR_PROCESS_PGRP_PROPERTY, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_PGRP_PROPERTY] = g_param_spec_int ("pgrp", "pgrp", "pgrp", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1089 "Process.c"
	/**
	     * Command from stat file, truncated to 16 chars
	     */
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMM_PROPERTY, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMM_PROPERTY] = g_param_spec_string ("comm", "comm", "comm", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1095 "Process.c"
	/**
	     * Full command from cmdline file
	     */
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMMAND_PROPERTY, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMMAND_PROPERTY] = g_param_spec_string ("command", "command", "command", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1101 "Process.c"
	/**
	     * CPU usage of this process from the last time that it was updated, measured in percent
	     *
	     * Will be 0 on first update.
	     */
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_PROCESS_MONITOR_PROCESS_CPU_USAGE_PROPERTY, power_services_process_monitor_process_properties[POWER_SERVICES_PROCESS_MONITOR_PROCESS_CPU_USAGE_PROPERTY] = g_param_spec_double ("cpu-usage", "cpu-usage", "cpu-usage", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1109 "Process.c"
}

static void
power_services_process_monitor_process_instance_init (PowerServicesProcessMonitorProcess * self,
                                                      gpointer klass)
{
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	self->priv = power_services_process_monitor_process_get_instance_private (self);
#line 1118 "Process.c"
}

static void
power_services_process_monitor_process_finalize (GObject * obj)
{
	PowerServicesProcessMonitorProcess * self;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_SERVICES_PROCESS_MONITOR_TYPE_PROCESS, PowerServicesProcessMonitorProcess);
#line 44 "../src/Services/ProcessMonitor/Process.vala"
	_g_free0 (self->priv->_comm);
#line 49 "../src/Services/ProcessMonitor/Process.vala"
	_g_free0 (self->priv->_command);
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	G_OBJECT_CLASS (power_services_process_monitor_process_parent_class)->finalize (obj);
#line 1133 "Process.c"
}

static GType
power_services_process_monitor_process_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerServicesProcessMonitorProcessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_services_process_monitor_process_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerServicesProcessMonitorProcess), 0, (GInstanceInitFunc) power_services_process_monitor_process_instance_init, NULL };
	GType power_services_process_monitor_process_type_id;
	power_services_process_monitor_process_type_id = g_type_register_static (G_TYPE_OBJECT, "PowerServicesProcessMonitorProcess", &g_define_type_info, 0);
	PowerServicesProcessMonitorProcess_private_offset = g_type_add_instance_private (power_services_process_monitor_process_type_id, sizeof (PowerServicesProcessMonitorProcessPrivate));
	return power_services_process_monitor_process_type_id;
}

GType
power_services_process_monitor_process_get_type (void)
{
	static volatile gsize power_services_process_monitor_process_type_id__once = 0;
	if (g_once_init_enter (&power_services_process_monitor_process_type_id__once)) {
		GType power_services_process_monitor_process_type_id;
		power_services_process_monitor_process_type_id = power_services_process_monitor_process_get_type_once ();
		g_once_init_leave (&power_services_process_monitor_process_type_id__once, power_services_process_monitor_process_type_id);
	}
	return power_services_process_monitor_process_type_id__once;
}

static void
_vala_power_services_process_monitor_process_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	PowerServicesProcessMonitorProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_SERVICES_PROCESS_MONITOR_TYPE_PROCESS, PowerServicesProcessMonitorProcess);
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	switch (property_id) {
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_EXISTS_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		g_value_set_boolean (value, power_services_process_monitor_process_get_exists (self));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_PID_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		g_value_set_int (value, power_services_process_monitor_process_get_pid (self));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_PPID_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		g_value_set_int (value, power_services_process_monitor_process_get_ppid (self));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_PGRP_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		g_value_set_int (value, power_services_process_monitor_process_get_pgrp (self));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMM_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		g_value_set_string (value, power_services_process_monitor_process_get_comm (self));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMMAND_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		g_value_set_string (value, power_services_process_monitor_process_get_command (self));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_CPU_USAGE_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		g_value_set_double (value, power_services_process_monitor_process_get_cpu_usage (self));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 1210 "Process.c"
		default:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 1216 "Process.c"
	}
}

static void
_vala_power_services_process_monitor_process_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	PowerServicesProcessMonitorProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_SERVICES_PROCESS_MONITOR_TYPE_PROCESS, PowerServicesProcessMonitorProcess);
#line 20 "../src/Services/ProcessMonitor/Process.vala"
	switch (property_id) {
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_EXISTS_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_exists (self, g_value_get_boolean (value));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_PID_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_pid (self, g_value_get_int (value));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_PPID_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_ppid (self, g_value_get_int (value));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_PGRP_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_pgrp (self, g_value_get_int (value));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMM_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_comm (self, g_value_get_string (value));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_COMMAND_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_command (self, g_value_get_string (value));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		case POWER_SERVICES_PROCESS_MONITOR_PROCESS_CPU_USAGE_PROPERTY:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		power_services_process_monitor_process_set_cpu_usage (self, g_value_get_double (value));
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 1272 "Process.c"
		default:
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Services/ProcessMonitor/Process.vala"
		break;
#line 1278 "Process.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

